@echo off
goto checkparam

   This batch file was written by
   M&M Corporation Budapest

   %0=RECOMP - program name
   %1=ZIP    - %2=filespec, maybe with wildcards
   %1=!      - start process, %2=compressor
                              %3=decompressor (=archive extension)
                              %4=filespec w/o extension
   %1=!!     - decompress, %2=decompressor
                           %3=filespec w/o ext.
   %1=!!!    - compress, %2=compressor
                         %3=filespec w/o ext.
   %1=!!!!   - compress ONLY, %2=compressor
                              %3=filespec for WITH
                              %4=archive name
   %1=!!!!!  - decompress ONLY, %2=decompressor
                                %3=filespec w/o ext.

:checkparam
if .%1 == . goto end
if %1 == /? goto about
if %1 == ! goto startprocess
if %1 == !! goto decompress
if %1 == !!! goto compress
if %1 == !!!! goto componly
if %1 == !!!!! goto decomponly

:testwith
with /t
if errorlevel 255 goto withfound
goto nowith
:withfound
if not .%2 == . goto onefile
:eachfile
with /c *.AIN;*.ARJ;*.HPK;*.HYP;*.ICE;*.LHA;*.LZH;*.PAK;*.RAR;*.SQZ;*.UC2;*.YC;*.Z;*.ZIP;*.ZOO call %0 %1 ~b
goto end

:onefile
if not exist %2 goto notexist
with %2 call %0 ! %1 ~e ~n
goto end

:startprocess
if .%4 == . goto inter
if %3 == AIN goto startit
if %3 == ARJ goto startit
if %3 == HPK goto startit
if %3 == HYP goto startit
if %3 == ICE goto startit
if %3 == LHA goto startit
if %3 == LZH goto startit
if %3 == PAK goto startit
if %3 == RAR goto startit
if %3 == SQZ goto startit
if %3 == UC2 goto startit
if %3 == YC  goto startit
if %3 == Z   goto startit
if %3 == ZIP goto startit
if %3 == ZOO goto startit
goto notarchive
:startit 
md ~recomp.tmp
cd ~recomp.tmp
call %0 !! %3 %4
call %0 !!! %2 %4
cd ..
deltree -y ~recomp.tmp >nul
goto end

:decompress
if .%3 == . goto dcnofile
if .%2 == . goto dcnocomp
if %2 == AIN goto dstartit
if %2 == ARJ goto dstartit
if %2 == HPK goto dstartit
if %2 == HYP goto dstartit
if %2 == ICE goto dstartit
if %2 == LHA goto dstartit
if %2 == LZH goto dstartit
if %2 == PAK goto dstartit
if %2 == RAR goto dstartit
if %2 == SQZ goto dstartit
if %2 == UC2 goto dstartit
if %2 == YC  goto dstartit
if %2 == Z   goto dstartit
if %2 == ZIP goto dstartit
if %2 == ZOO goto dstartit
goto notarchive
:dstartit
echo.
echo Ŀ
echo  Decompress... 
echo 
rem *
rem * beep
rem * echo 
rem *
goto _%2
:_ain
ain x -y ..\%3
goto end
:_arj
arj x -y ..\%3
goto end
:_hpk
hpack x -oA -e ..\%3
goto end
:_hyp
hyper -xo ..\%3
goto end
:_ice
lhice x ..\%3
goto end
:_lha
lha x -f ..\%3.lha
goto end
:_lzh
lha x -f ..\%3
goto end
:_rar
rar x -std -av- -c- -o+ -y ..\%3
goto end
:_sqz
sqz x -O1 ..\%3
goto end
:_uc2
uc x -s -f ..\%3
goto end
:_yc
yac x -bw ..\%3
goto end
:_z
copy ..\%3.z . /y >nul
gzip -dfNv %3.z
goto end
:_zip
pkunzip -d -o ..\%3
goto end
:_zoo
zoo xO ..\%3
goto end

:compress
if .%3 == . goto cnofile
if .%2 == . goto cnocomp
if %2 == AIN goto cstartit
if %2 == ARJ goto cstartit
if %2 == HPK goto cstartit
if %2 == HYP goto cstartit
if %2 == ICE goto cstartit
if %2 == LHA goto cstartit
if %2 == LZH goto cstartit
if %2 == PAK goto cstartit
if %2 == RAR goto cstartit
if %2 == SQZ goto cstartit
if %2 == UC2 goto cstartit
if %2 == YC  goto cstartit
if %2 == Z   goto cstartit
if %2 == ZIP goto cstartit
if %2 == ZOO goto cstartit
goto notarchive
:cstartit
echo.
echo Ŀ
echo  Compress... 
echo 
rem *
rem * beep
rem * echo 
rem *
goto %2
:ain
ain a -m1 -r -.xm ..\%3
goto end
:arj
arj a -jm -r -y ..\%3
goto end
:hpk
hpack a -a -e -k -r ..\%3
goto end
:hyp
hyper -a -r ..\%3
goto end
:ice
lhice a -r ..\%3
goto end
:lha
:lzh
lha a -r -d ..\%3
goto end
:rar
rar a -s -m5 -std -r -av- ..\%3
goto end
:sqz
sqz a -S -m4 -q0 ..\%3
goto end
:uc2
uc a -s -f -tt ..\%3
goto end
:yc
yac a -bw -le4m -lx4m -r ..\%3
goto end
:z
echo.
echo Warning!!! GZIP cannot store subdirectories!
choice /c:yn /t:n,5 /n "Compress files one by one? "
if errorlevel 2 goto end
with /q *.* gzip -cNv9 ~b ~)..\~n.z
goto end
:zip
pkzip -a -ex -whs -p -r -o ..\%3
goto end
:zoo
echo.
echo Warning!!! ZOO cannot store subdirectories automatically!
choice /c:yn /t:n,5 /n "Continue compressing with ZOO? "
if errorlevel 2 goto end
zoo ah ..\%3 *.*
goto end

:componly
with /t
if errorlevel 255 goto cwithfound
goto nowith
:cwithfound
md ~compres.tmp
echo Copying files...
with /q %3 copy ~b ~~compres.tmp ~)nul
cd ~compres.tmp
call %0 !!! %2 %4
cd ..
deltree -y ~compres.tmp >nul
goto end

:decomponly
with /t
if errorlevel 255 goto dwithfound
goto nowith
:dwithfound
md ~decompr.tmp
cd ~decompr.tmp
call %0 !! %2 %3
move -y .\*.* .. >nul
cd ..
deltree -y ~decompr.tmp >nul
goto end

:about
echo ReComp v1.00 (c) 1996 M&M Corporation Budapest
echo Usage: %0 [compressor] [source]
echo [compressor]
echo     Either AIN, ARJ, HPK, HYP, ICE, LHA, LZH, PAK, RAR,
echo            SQZ, UC2, YC, Z, ZIP, or ZOO
echo     The chosen compressor should exist on your path.
echo [source]
echo     Any type of compressed archive, with its DEFAULT extension
echo     (ie. ZIP for PkZipped files, Z for GZipped files)
goto end

:cnofile
echo No file specified.
echo [c] [%1] [%2] [%3] [%4]
goto end

:dcnofile
echo No file specified.
echo [d] [%1] [%2] [%3] [%4]
goto end

:cnocomp
echo No compression utility specified.
echo [c] [%1] [%2] [%3] [%4]
goto end

:dcnocomp
echo No compression utility specified.
echo [d] [%1] [%2] [%3] [%4]
goto end

:notexist
echo File not found.
goto end

:nowith
echo This program requires WITH.EXE v1.04b+ on your path.
goto end

:inter
echo Internal error: No file.
goto end

:notarchive
echo Invalid extension. Maybe not a compressed archive.
goto end

:end
